// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteering.idl
// generated code does not contain a copyright notice

#ifndef FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__TRAITS_HPP_
#define FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace four_wheel_steering_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FourWheelSteering & msg,
  std::ostream & out)
{
  out << "{";
  // member: front_steering_angle
  {
    out << "front_steering_angle: ";
    rosidl_generator_traits::value_to_yaml(msg.front_steering_angle, out);
    out << ", ";
  }

  // member: rear_steering_angle
  {
    out << "rear_steering_angle: ";
    rosidl_generator_traits::value_to_yaml(msg.rear_steering_angle, out);
    out << ", ";
  }

  // member: front_steering_angle_velocity
  {
    out << "front_steering_angle_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.front_steering_angle_velocity, out);
    out << ", ";
  }

  // member: rear_steering_angle_velocity
  {
    out << "rear_steering_angle_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.rear_steering_angle_velocity, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    rosidl_generator_traits::value_to_yaml(msg.speed, out);
    out << ", ";
  }

  // member: acceleration
  {
    out << "acceleration: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration, out);
    out << ", ";
  }

  // member: jerk
  {
    out << "jerk: ";
    rosidl_generator_traits::value_to_yaml(msg.jerk, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FourWheelSteering & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: front_steering_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "front_steering_angle: ";
    rosidl_generator_traits::value_to_yaml(msg.front_steering_angle, out);
    out << "\n";
  }

  // member: rear_steering_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rear_steering_angle: ";
    rosidl_generator_traits::value_to_yaml(msg.rear_steering_angle, out);
    out << "\n";
  }

  // member: front_steering_angle_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "front_steering_angle_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.front_steering_angle_velocity, out);
    out << "\n";
  }

  // member: rear_steering_angle_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rear_steering_angle_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.rear_steering_angle_velocity, out);
    out << "\n";
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed: ";
    rosidl_generator_traits::value_to_yaml(msg.speed, out);
    out << "\n";
  }

  // member: acceleration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration, out);
    out << "\n";
  }

  // member: jerk
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "jerk: ";
    rosidl_generator_traits::value_to_yaml(msg.jerk, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FourWheelSteering & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace four_wheel_steering_msgs

namespace rosidl_generator_traits
{

[[deprecated("use four_wheel_steering_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const four_wheel_steering_msgs::msg::FourWheelSteering & msg,
  std::ostream & out, size_t indentation = 0)
{
  four_wheel_steering_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use four_wheel_steering_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const four_wheel_steering_msgs::msg::FourWheelSteering & msg)
{
  return four_wheel_steering_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<four_wheel_steering_msgs::msg::FourWheelSteering>()
{
  return "four_wheel_steering_msgs::msg::FourWheelSteering";
}

template<>
inline const char * name<four_wheel_steering_msgs::msg::FourWheelSteering>()
{
  return "four_wheel_steering_msgs/msg/FourWheelSteering";
}

template<>
struct has_fixed_size<four_wheel_steering_msgs::msg::FourWheelSteering>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<four_wheel_steering_msgs::msg::FourWheelSteering>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<four_wheel_steering_msgs::msg::FourWheelSteering>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__TRAITS_HPP_
