// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteering.idl
// generated code does not contain a copyright notice

#ifndef FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__BUILDER_HPP_
#define FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace four_wheel_steering_msgs
{

namespace msg
{

namespace builder
{

class Init_FourWheelSteering_jerk
{
public:
  explicit Init_FourWheelSteering_jerk(::four_wheel_steering_msgs::msg::FourWheelSteering & msg)
  : msg_(msg)
  {}
  ::four_wheel_steering_msgs::msg::FourWheelSteering jerk(::four_wheel_steering_msgs::msg::FourWheelSteering::_jerk_type arg)
  {
    msg_.jerk = std::move(arg);
    return std::move(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

class Init_FourWheelSteering_acceleration
{
public:
  explicit Init_FourWheelSteering_acceleration(::four_wheel_steering_msgs::msg::FourWheelSteering & msg)
  : msg_(msg)
  {}
  Init_FourWheelSteering_jerk acceleration(::four_wheel_steering_msgs::msg::FourWheelSteering::_acceleration_type arg)
  {
    msg_.acceleration = std::move(arg);
    return Init_FourWheelSteering_jerk(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

class Init_FourWheelSteering_speed
{
public:
  explicit Init_FourWheelSteering_speed(::four_wheel_steering_msgs::msg::FourWheelSteering & msg)
  : msg_(msg)
  {}
  Init_FourWheelSteering_acceleration speed(::four_wheel_steering_msgs::msg::FourWheelSteering::_speed_type arg)
  {
    msg_.speed = std::move(arg);
    return Init_FourWheelSteering_acceleration(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

class Init_FourWheelSteering_rear_steering_angle_velocity
{
public:
  explicit Init_FourWheelSteering_rear_steering_angle_velocity(::four_wheel_steering_msgs::msg::FourWheelSteering & msg)
  : msg_(msg)
  {}
  Init_FourWheelSteering_speed rear_steering_angle_velocity(::four_wheel_steering_msgs::msg::FourWheelSteering::_rear_steering_angle_velocity_type arg)
  {
    msg_.rear_steering_angle_velocity = std::move(arg);
    return Init_FourWheelSteering_speed(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

class Init_FourWheelSteering_front_steering_angle_velocity
{
public:
  explicit Init_FourWheelSteering_front_steering_angle_velocity(::four_wheel_steering_msgs::msg::FourWheelSteering & msg)
  : msg_(msg)
  {}
  Init_FourWheelSteering_rear_steering_angle_velocity front_steering_angle_velocity(::four_wheel_steering_msgs::msg::FourWheelSteering::_front_steering_angle_velocity_type arg)
  {
    msg_.front_steering_angle_velocity = std::move(arg);
    return Init_FourWheelSteering_rear_steering_angle_velocity(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

class Init_FourWheelSteering_rear_steering_angle
{
public:
  explicit Init_FourWheelSteering_rear_steering_angle(::four_wheel_steering_msgs::msg::FourWheelSteering & msg)
  : msg_(msg)
  {}
  Init_FourWheelSteering_front_steering_angle_velocity rear_steering_angle(::four_wheel_steering_msgs::msg::FourWheelSteering::_rear_steering_angle_type arg)
  {
    msg_.rear_steering_angle = std::move(arg);
    return Init_FourWheelSteering_front_steering_angle_velocity(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

class Init_FourWheelSteering_front_steering_angle
{
public:
  Init_FourWheelSteering_front_steering_angle()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_FourWheelSteering_rear_steering_angle front_steering_angle(::four_wheel_steering_msgs::msg::FourWheelSteering::_front_steering_angle_type arg)
  {
    msg_.front_steering_angle = std::move(arg);
    return Init_FourWheelSteering_rear_steering_angle(msg_);
  }

private:
  ::four_wheel_steering_msgs::msg::FourWheelSteering msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::four_wheel_steering_msgs::msg::FourWheelSteering>()
{
  return four_wheel_steering_msgs::msg::builder::Init_FourWheelSteering_front_steering_angle();
}

}  // namespace four_wheel_steering_msgs

#endif  // FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__BUILDER_HPP_
