// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteering.idl
// generated code does not contain a copyright notice

#ifndef FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__STRUCT_HPP_
#define FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__four_wheel_steering_msgs__msg__FourWheelSteering __attribute__((deprecated))
#else
# define DEPRECATED__four_wheel_steering_msgs__msg__FourWheelSteering __declspec(deprecated)
#endif

namespace four_wheel_steering_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FourWheelSteering_
{
  using Type = FourWheelSteering_<ContainerAllocator>;

  explicit FourWheelSteering_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_steering_angle = 0.0f;
      this->rear_steering_angle = 0.0f;
      this->front_steering_angle_velocity = 0.0f;
      this->rear_steering_angle_velocity = 0.0f;
      this->speed = 0.0f;
      this->acceleration = 0.0f;
      this->jerk = 0.0f;
    }
  }

  explicit FourWheelSteering_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->front_steering_angle = 0.0f;
      this->rear_steering_angle = 0.0f;
      this->front_steering_angle_velocity = 0.0f;
      this->rear_steering_angle_velocity = 0.0f;
      this->speed = 0.0f;
      this->acceleration = 0.0f;
      this->jerk = 0.0f;
    }
  }

  // field types and members
  using _front_steering_angle_type =
    float;
  _front_steering_angle_type front_steering_angle;
  using _rear_steering_angle_type =
    float;
  _rear_steering_angle_type rear_steering_angle;
  using _front_steering_angle_velocity_type =
    float;
  _front_steering_angle_velocity_type front_steering_angle_velocity;
  using _rear_steering_angle_velocity_type =
    float;
  _rear_steering_angle_velocity_type rear_steering_angle_velocity;
  using _speed_type =
    float;
  _speed_type speed;
  using _acceleration_type =
    float;
  _acceleration_type acceleration;
  using _jerk_type =
    float;
  _jerk_type jerk;

  // setters for named parameter idiom
  Type & set__front_steering_angle(
    const float & _arg)
  {
    this->front_steering_angle = _arg;
    return *this;
  }
  Type & set__rear_steering_angle(
    const float & _arg)
  {
    this->rear_steering_angle = _arg;
    return *this;
  }
  Type & set__front_steering_angle_velocity(
    const float & _arg)
  {
    this->front_steering_angle_velocity = _arg;
    return *this;
  }
  Type & set__rear_steering_angle_velocity(
    const float & _arg)
  {
    this->rear_steering_angle_velocity = _arg;
    return *this;
  }
  Type & set__speed(
    const float & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__acceleration(
    const float & _arg)
  {
    this->acceleration = _arg;
    return *this;
  }
  Type & set__jerk(
    const float & _arg)
  {
    this->jerk = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator> *;
  using ConstRawPtr =
    const four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__four_wheel_steering_msgs__msg__FourWheelSteering
    std::shared_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__four_wheel_steering_msgs__msg__FourWheelSteering
    std::shared_ptr<four_wheel_steering_msgs::msg::FourWheelSteering_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FourWheelSteering_ & other) const
  {
    if (this->front_steering_angle != other.front_steering_angle) {
      return false;
    }
    if (this->rear_steering_angle != other.rear_steering_angle) {
      return false;
    }
    if (this->front_steering_angle_velocity != other.front_steering_angle_velocity) {
      return false;
    }
    if (this->rear_steering_angle_velocity != other.rear_steering_angle_velocity) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->acceleration != other.acceleration) {
      return false;
    }
    if (this->jerk != other.jerk) {
      return false;
    }
    return true;
  }
  bool operator!=(const FourWheelSteering_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FourWheelSteering_

// alias to use template instance with default allocator
using FourWheelSteering =
  four_wheel_steering_msgs::msg::FourWheelSteering_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace four_wheel_steering_msgs

#endif  // FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING__STRUCT_HPP_
