// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from four_wheel_steering_msgs:msg/FourWheelSteeringStamped.idl
// generated code does not contain a copyright notice

#ifndef FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING_STAMPED__FUNCTIONS_H_
#define FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING_STAMPED__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "four_wheel_steering_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "four_wheel_steering_msgs/msg/detail/four_wheel_steering_stamped__struct.h"

/// Initialize msg/FourWheelSteeringStamped message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped
 * )) before or use
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init(four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg);

/// Finalize msg/FourWheelSteeringStamped message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini(four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg);

/// Create msg/FourWheelSteeringStamped message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
four_wheel_steering_msgs__msg__FourWheelSteeringStamped *
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__create();

/// Destroy msg/FourWheelSteeringStamped message.
/**
 * It calls
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__destroy(four_wheel_steering_msgs__msg__FourWheelSteeringStamped * msg);

/// Check for msg/FourWheelSteeringStamped message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__are_equal(const four_wheel_steering_msgs__msg__FourWheelSteeringStamped * lhs, const four_wheel_steering_msgs__msg__FourWheelSteeringStamped * rhs);

/// Copy a msg/FourWheelSteeringStamped message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__copy(
  const four_wheel_steering_msgs__msg__FourWheelSteeringStamped * input,
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped * output);

/// Initialize array of msg/FourWheelSteeringStamped messages.
/**
 * It allocates the memory for the number of elements and calls
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__init(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array, size_t size);

/// Finalize array of msg/FourWheelSteeringStamped messages.
/**
 * It calls
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__fini(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array);

/// Create array of msg/FourWheelSteeringStamped messages.
/**
 * It allocates the memory for the array and calls
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence *
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__create(size_t size);

/// Destroy array of msg/FourWheelSteeringStamped messages.
/**
 * It calls
 * four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
void
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__destroy(four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * array);

/// Check for msg/FourWheelSteeringStamped message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__are_equal(const four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * lhs, const four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * rhs);

/// Copy an array of msg/FourWheelSteeringStamped messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_four_wheel_steering_msgs
bool
four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence__copy(
  const four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * input,
  four_wheel_steering_msgs__msg__FourWheelSteeringStamped__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // FOUR_WHEEL_STEERING_MSGS__MSG__DETAIL__FOUR_WHEEL_STEERING_STAMPED__FUNCTIONS_H_
